package fer.hr.preprocessing.greyscale;

import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * Created by jcular on 3/17/16.
 */
public class Greyscale implements IGreyscaleConvert {

    @Override
    public BufferedImage convertToGrey(BufferedImage oldImage) {
        for (int i = 0; i < oldImage.getHeight(); i++) {
            for (int j = 0; j < oldImage.getWidth(); j++) {
                Color pixelColor = new Color(oldImage.getRGB(j, i));
                int alpha = pixelColor.getAlpha();
                int r = pixelColor.getRed();
                int g = pixelColor.getGreen();
                int b = pixelColor.getBlue();
                int rgb = convertRGBToGrey(r,g,b);
                int newPixel = combineRGB(alpha, rgb, rgb, rgb);
                oldImage.setRGB(j, i, newPixel);
            }
        }
        return oldImage;
    }

    private int convertRGBToGrey(int r, int g, int b) {
        return (int) Math.round(1./3 * r + 1./3 * g + 1./3 * b);
    }

    private int combineRGB(int alpha, int r, int g, int b) {
        int newPixel = alpha;
        newPixel = newPixel << 8;
        newPixel += r;
        newPixel = newPixel << 8;
        newPixel += g;
        newPixel = newPixel << 8;
        newPixel += b;
        return newPixel;
    }
}
